## PothosPlotters-0.4.2.tar.gz

=== CMakeLists.txt ===
########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 3.1.0)
project(PothosPlotters CXX)

if(${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
    find_package(Pothos "0.6.0" CONFIG REQUIRED)
else()
    find_package(Pothos CONFIG REQUIRED) #in-tree build
endif()

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

#args to set the CMAKE_PREFIX_PATH environment variable
if (CMAKE_PREFIX_PATH)
    set(ENV{CMAKE_PREFIX_PATH} ${CMAKE_PREFIX_PATH})
endif (CMAKE_PREFIX_PATH)

include(GNUInstallDirs)

########################################################################
# Qt devel setup
########################################################################
find_package(QT NAMES Qt6 Qt5 COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets Concurrent)
message(STATUS "QT_VERSION_MAJOR=${QT_VERSION_MAJOR}")
set(CMAKE_AUTOMOC ON)

########################################################################
# Spuce library
########################################################################
if(NOT SPUCE_IN_TREE)
    find_package(Spuce CONFIG)
endif(NOT SPUCE_IN_TREE)

if (Spuce_FOUND)
    message(STATUS "Spuce_VERSION: ${Spuce_VERSION}")
    message(STATUS "Spuce_INCLUDE_DIRS: ${Spuce_INCLUDE_DIRS}")
    message(STATUS "Spuce_LIBRARIES: ${Spuce_LIBRARIES}")
    if (NOT TARGET spuce)
    add_library(spuce INTERFACE)
    target_link_libraries(spuce INTERFACE "${Spuce_LIBRARIES}")
    target_include_directories(spuce INTERFACE "${Spuce_INCLUDE_DIRS}")
    endif()
else (Spuce_FOUND)
    message(WARNING "Spuce filter designer library not found...")
endif (Spuce_FOUND)

########################################################################
## Feature registration
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_PLOTTERS "Enable Pothos Plotters component" ON "Pothos_FOUND;Qt${QT_VERSION_MAJOR}_FOUND" OFF)
add_feature_info(Plotters ENABLE_PLOTTERS "Graphical plotter widgets for the GUI")

########################################################################
# Qwt setup
########################################################################
find_package(Qwt)

if (QWT_FOUND AND NOT QWT_VERSION_STRING)
    message(WARNING "Failed to extract QWT_VERSION_STRING from ${QWT_INCLUDE_DIRS} - using built-in Qwt")
    set(QWT_FOUND FALSE)
endif()

if (QWT_FOUND)
    message(STATUS "QWT_VERSION_STRING: ${QWT_VERSION_STRING}")
    if (QWT_VERSION_STRING LESS "6.1")
        set(QWT_FOUND FALSE)
        message(STATUS "Qwt older than v6.1 - using built-in Qwt")
    endif()
else (QWT_FOUND)
    message(STATUS "Qwt not found - using built-in Qwt")
endif (QWT_FOUND)

if (QWT_FOUND)

    add_library(PothosQwt INTERFACE)
    target_link_libraries(PothosQwt INTERFACE "${QWT_LIBRARIES}")
    target_include_directories(PothosQwt INTERFACE "${QWT_INCLUDE_DIRS}")
    target_compile_definitions(PothosQwt INTERFACE -DQWT_DLL)
    message(STATUS "QWT_INCLUDE_DIRS: ${QWT_INCLUDE_DIRS}")
    message(STATUS "QWT_LIBRARIES: ${QWT_LIBRARIES}")

elseif (ENABLE_PLOTTERS)

    #compiling qwt from source requires many more Qt libraries
    find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Widgets Concurrent OpenGL Svg PrintSupport)

    set(QWT_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/qwt6/src)

    if (NOT EXISTS ${QWT_SRC_DIR})
        message(FATAL_ERROR "Qwt submodule not configured (git submodule update --init --recursive)")
    endif ()

    set (QWT_VERSION_STRING 0)
    set ( _VERSION_FILE ${QWT_SRC_DIR}/qwt_global.h )
    if ( EXISTS ${_VERSION_FILE} )
      file ( STRINGS ${_VERSION_FILE} _VERSION_LINE REGEX "define[ ]+QWT_VERSION_STR" )
      if ( _VERSION_LINE )
        string ( REGEX REPLACE ".*define[ ]+QWT_VERSION_STR[ ]+\"(.*)\".*" "\\1" QWT_VERSION_STRING "${_VERSION_LINE}" )
      endif ()
    endif ()
    message(STATUS "QWT_VERSION_STRING: ${QWT_VERSION_STRING}")

    file(GLOB QWT_SOURCES "${QWT_SRC_DIR}/*.cpp")
    add_library(PothosQwt SHARED ${QWT_SOURCES})
    target_include_directories(PothosQwt PUBLIC ${QWT_SRC_DIR})
    set_target_properties(PothosQwt PROPERTIES DEFINE_SYMBOL "QWT_MAKEDLL")
    set_target_properties(PothosQwt PROPERTIES VERSION ${QWT_VERSION_STRING})
    target_link_libraries(PothosQwt PRIVATE Qt${QT_VERSION_MAJOR}::Widgets)
    target_link_libraries(PothosQwt PRIVATE Qt${QT_VERSION_MAJOR}::OpenGL)
    target_link_libraries(PothosQwt PRIVATE Qt${QT_VERSION_MAJOR}::Concurrent)
    target_link_libraries(PothosQwt PRIVATE Qt${QT_VERSION_MAJOR}::PrintSupport)
    target_link_libraries(PothosQwt PRIVATE Qt${QT_VERSION_MAJOR}::Svg)
    target_compile_definitions(PothosQwt PUBLIC -DQWT_DLL)
    install(TARGETS PothosQwt
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} # .so file
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} # .lib file
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} # .dll file
    )

endif (QWT_FOUND)

########################################################################
# plotter utils library
########################################################################
if (ENABLE_PLOTTERS)

file(GLOB PLOTTER_UTILS_SOURCES "PlotterUtils/*.cpp")
add_library(PothosPlotterUtils SHARED ${PLOTTER_UTILS_SOURCES})
target_include_directories(PothosPlotterUtils PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/PlotterUtils)
set_target_properties(PothosPlotterUtils PROPERTIES DEFINE_SYMBOL "POTHOS_PLOTTER_UTILS_MAKEDLL")
set_target_properties(PothosPlotterUtils PROPERTIES VERSION 0.2.0)
target_link_libraries(PothosPlotterUtils PRIVATE Qt${QT_VERSION_MAJOR}::Widgets)
target_link_libraries(PothosPlotterUtils PRIVATE PothosQwt)
target_link_libraries(PothosPlotterUtils PRIVATE Pothos)
install(TARGETS PothosPlotterUtils
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} # .so file
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} # .lib file
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} # .dll file
)

endif (ENABLE_PLOTTERS)

########################################################################
# Build plotter widgets
########################################################################
add_subdirectory(Constellation)
add_subdirectory(LogicAnalyzer)
add_subdirectory(Periodogram)
add_subdirectory(QwtWidgets)
add_subdirectory(Spectrogram)
add_subdirectory(WaveMonitor)

=== Constellation/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_CONSTELLATION "Enable Pothos Plotters.Constellation component" ON "ENABLE_PLOTTERS" OFF)
add_feature_info("  Constellation" ENABLE_PLOTTERS_CONSTELLATION "Constellation complex IQ data plotter")
if (NOT ENABLE_PLOTTERS_CONSTELLATION)
    return()
endif()

########################################################################
# Build constellation plot module
########################################################################
POTHOS_MODULE_UTIL(
    TARGET Constellation
    SOURCES
        Constellation.cpp
        ConstellationWork.cpp
        ConstellationDisplay.cpp
    DOC_SOURCES Constellation.cpp
    LIBRARIES
        Qt${QT_VERSION_MAJOR}::Widgets
        PothosQwt
        PothosPlotterUtils
    DESTINATION plotters
)

=== LogicAnalyzer/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_LOGICANALYZER "Enable Pothos Plotters.LogicAnalyzer component" ON "ENABLE_PLOTTERS" OFF)
add_feature_info("  Logic Analyzer" ENABLE_PLOTTERS_LOGICANALYZER "Logic analyzer list-view debug display")
if (NOT ENABLE_PLOTTERS_LOGICANALYZER)
    return()
endif()

########################################################################
# Build logic analyzer plot module
########################################################################
POTHOS_MODULE_UTIL(
    TARGET LogicAnalyzer
    SOURCES
        LogicAnalyzer.cpp
        LogicAnalyzerDisplay.cpp
    DOC_SOURCES LogicAnalyzer.cpp
    LIBRARIES
        Qt${QT_VERSION_MAJOR}::Widgets
        PothosPlotterUtils
    DESTINATION plotters
)

=== Periodogram/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_PERIODOGRAM "Enable Pothos Plotters.Periodogram component" ON "Spuce_FOUND;ENABLE_PLOTTERS" OFF)
add_feature_info("  Periodogram" ENABLE_PLOTTERS_PERIODOGRAM "Periodogram frequency-domain FFT plotter")
if (NOT ENABLE_PLOTTERS_PERIODOGRAM)
    return()
endif()

########################################################################
# Build frequency domain plot module
########################################################################
POTHOS_MODULE_UTIL(
    TARGET Periodogram
    SOURCES
        Periodogram.cpp
        PeriodogramWork.cpp
        PeriodogramChannel.cpp
        PeriodogramDisplay.cpp
    DOC_SOURCES Periodogram.cpp
    LIBRARIES
        Qt${QT_VERSION_MAJOR}::Widgets
        PothosQwt
        PothosPlotterUtils
        spuce
    DESTINATION plotters
)

=== QwtWidgets/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_QWTWIDGETS "Enable Pothos Plotters.QwtWidgets component" ON "ENABLE_PLOTTERS" OFF)
add_feature_info("  Qwt Widgets" ENABLE_PLOTTERS_QWTWIDGETS "Miscellaneous widgets based around Qwt")
if (NOT ENABLE_PLOTTERS_QWTWIDGETS)
    return()
endif()

########################################################################
# Build Qwt widgets module
########################################################################
POTHOS_MODULE_UTIL(
    TARGET QwtWidgets
    SOURCES
        QwtSlider.cpp
        QwtThermo.cpp
        QwtKnob.cpp
        QwtDial.cpp
    ENABLE_DOCS
    LIBRARIES
        Qt${QT_VERSION_MAJOR}::Widgets
        PothosQwt
    DESTINATION plotters
)

=== Spectrogram/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_SPECTROGRAM "Enable Pothos Plotters.Spectrogram component" ON "ENABLE_PLOTTERS;Spuce_FOUND" OFF)
add_feature_info("  Spectrogram" ENABLE_PLOTTERS_SPECTROGRAM "Spectrogram frequency-domain FFT plotter")
if (NOT ENABLE_PLOTTERS_SPECTROGRAM)
    return()
endif()

########################################################################
# Build spectrogram plot module
########################################################################
include_directories(${Spuce_INCLUDE_DIRS})

POTHOS_MODULE_UTIL(
    TARGET Spectrogram
    SOURCES
        Spectrogram.cpp
        SpectrogramWork.cpp
        SpectrogramDisplay.cpp
        ColorMapEntry.cpp
        GeneratedColorMaps.cpp
        QwtColorMapMaker.cpp
    DOC_SOURCES Spectrogram.cpp
    LIBRARIES
        Qt${QT_VERSION_MAJOR}::Widgets
        PothosQwt
        PothosPlotterUtils
        spuce
    DESTINATION plotters
)

=== WaveMonitor/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
cmake_dependent_option(ENABLE_PLOTTERS_WAVEMONITOR "Enable Pothos Plotters.WaveMonitor component" ON "ENABLE_PLOTTERS" OFF)
add_feature_info("  Wave Monitor" ENABLE_PLOTTERS_WAVEMONITOR "Wavemonitor time-domain waveform plotter")
if (NOT ENABLE_PLOTTERS_WAVEMONITOR)
    return()
endif()

########################################################################
# Build time domain plot module
########################################################################
POTHOS_MODULE_UTIL(
    TARGET WaveMonitor
    SOURCES
        WaveMonitor.cpp
        WaveMonitorWork.cpp
        WaveMonitorDisplay.cpp
    DOC_SOURCES WaveMonitor.cpp
    LIBRARIES
        Qt${QT_VERSION_MAJOR}::Widgets
        PothosQwt
        PothosPlotterUtils
    DESTINATION plotters
)

=== debian/changelog ===
pothos-plotters (0.4.2-1) unstable; urgency=low

  * Release 0.4.2 (2021-07-25)

 -- Josh Blum <josh@pothosware.com>  Sun, 25 Jul 2021 17:49:34 -0000

pothos-plotters (0.4.1-1) unstable; urgency=low

  * Release 0.4.1 (2018-04-24)

 -- Josh Blum <josh@pothosware.com>  Tue, 24 Apr 2018 20:30:21 -0000

pothos-plotters (0.4.0-1) unstable; urgency=low

  * Release 0.4.0 (2017-12-25)

 -- Josh Blum <josh@pothosware.com>  Mon, 25 Dec 2017 11:32:08 -0000

pothos-plotters (0.3.1-1) unstable; urgency=low

  * Release 0.3.1 (2017-06-22)

 -- Josh Blum <josh@pothosware.com>  Thu, 22 Jun 2017 19:53:40 -0000

pothos-plotters (0.3.0-1) unstable; urgency=low

  * Release 0.3.0 (2017-04-27)

 -- Josh Blum <josh@pothosware.com>  Thu, 27 Apr 2017 17:00:27 -0000

pothos-plotters (0.2.2-1) unstable; urgency=low

  * Release 0.2.2 (2017-04-23)

 -- Josh Blum <josh@pothosware.com>  Sun, 23 Apr 2017 20:38:10 -0000

pothos-plotters (0.2.1-ppa1) unstable; urgency=low

  * Release 0.2.1 (2016-09-24)

 -- Josh Blum <josh@pothosware.com>  Sun, 25 Sep 2016 09:29:56 -0700

pothos-plotters (0.2.0) unstable; urgency=low

  * Release 0.2.0 (2016-08-02)

 -- Josh Blum <josh@pothosware.com>  Tue, 02 Aug 2016 14:27:00 -0700

pothos-plotters (0.1.1) unstable; urgency=low

  * Release 0.1.1 (2016-05-10)

 -- Josh Blum <josh@pothosware.com>  Tue, 10 May 2016 16:22:03 -0700

pothos-plotters (0.1.0) unstable; urgency=low

  * Release 0.1.0 (2015-12-16)

 -- Josh Blum <josh@pothosware.com>  Wed, 16 Dec 2015 16:30:45 -0800

=== debian/control ===
Source: pothos-plotters
Section: science
Priority: optional
Maintainer: Josh Blum <josh@pothosware.com>
Build-Depends:
    debhelper (>= 9.0.0),
    cmake (>= 2.8.9),
    libpoco-dev (>= 1.6),
    libpothos-dev,
    libspuce-dev,
    qtbase5-dev, libqt5svg5-dev, libqt5opengl5-dev,
    libqwt-qt5-dev
Standards-Version: 4.5.0
Homepage: https://github.com/pothosware/PothosPlotters/wiki
Vcs-Git: https://github.com/pothosware/PothosPlotters.git
Vcs-Browser: https://github.com/pothosware/PothosPlotters

Package: pothos-modules-plotters
Section: libs
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: pothos0.7-modules-plotters, ${misc:Depends}
Description: graphical plotter widgets - metapackage
 The Pothos data-flow software suite.

Package: pothos0.7-modules-plotters
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpothosplotterutils0.2.0 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: graphical plotter widgets
 The Pothos data-flow software suite.

Package: libpothosplotterutils0.2.0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: plotter utility shared library
 The Pothos data-flow software suite.
